------------------------
-- Register File

-- 32bit register * 128
-------------------------
-------------------------------------------------------------------------------
-- Notes
---- 2007.01.26
------ BlockRAM𒼐ڌĂяo悤ɏB
------ FDR/EXW̋ŒłAȁBiSEL)
---- 2006.10.20 
------ Ƃ肠ABwrite enable͂ׂȂB
------ clockregister writê݁B
-------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

library UNISIM;
use UNISIM.VCOMPONENTS.all;

entity REGFILE is
  
  port (
    CLK   : in  std_logic;                       -- system clock
    SEL   : in std_logic;                        -- select '1'->EXW '0'->IFDR
    -- EXW
    REG_OA : out std_logic_vector(31 downto 0);   -- src reg1
    REG_OB : out std_logic_vector(31 downto 0);   -- src reg2
    REG_IB : in  std_logic_vector(31 downto 0);   -- dest reg
    WEX     : in std_logic;                 -- write enable
    REGAD_D : in std_logic_vector(6 downto 0);    -- dest/src reg addr
    -- IFDR
    REGAD_S : in std_logic_vector(6 downto 0);  -- src reg1 addr
    REGAD_T : in std_logic_vector(6 downto 0));  -- src reg2 addr

end REGFILE;
--sim:/cpu_sim/cpu_top_inst/regfile_inst
architecture ARC of REGFILE is
--  subtype word is std_logic_vector(31 downto 0);  -- register size
--  type REGISTERS is array (127 downto 0) of word;  -- register set type

--  signal REG_FILE : REGISTERS;          -- register set

    component RAMB16_S36_S36
        port(WEA : in std_logic;
            ENA : in std_logic;
            SSRA : in std_logic;
            CLKA : in std_logic;
            ADDRA : in std_logic_vector(8 downto 0);
            DIA : in std_logic_vector(31 downto 0);
            DIPA : in std_logic_vector(3 downto 0);
            DOA : out std_logic_vector(31 downto 0);
            DOPA : out std_logic_vector(3 downto 0);
            WEB : in std_logic;
            ENB : in std_logic;
            SSRB : in std_logic;
            CLKB : in std_logic;
            ADDRB : in std_logic_vector(8 downto 0);
            DIB : in std_logic_vector(31 downto 0);
            DIPB : in std_logic_vector(3 downto 0);
            DOB : out std_logic_vector(31 downto 0);
            DOPB : out std_logic_vector(3 downto 0));
    end component;

    signal ADA,ADB : std_logic_vector(8 downto 0);
    signal POA,POB : std_logic_vector(3 downto 0);
    signal WE : std_logic;  
    constant PI : std_logic_vector(3 downto 0) := "0000";       -- always 0
    constant E : std_logic := '1';                       -- always 1
    constant R : std_logic := '0';                       -- always 0
    constant ALL0 : std_logic_vector(31 downto 0) := (others => '0');
    constant R0 : std_logic_vector(7 downto 0) := (others => '0');

begin  -- arc_regfile

    -- port A, port B (IFDR/EXW)
    RAMB : RAMB16_S36_S36
        port map(WEA => R,
                ENA => E,
                SSRA => R,
                CLKA => CLK,
                ADDRA => ADA,
                DIA => ALL0,
                DIPA => PI,
                DOA => REG_OA,
                DOPA => POA,
                WEB => WE,
                ENB => E,
                SSRB => R,
                CLKB => CLK,
                ADDRB => ADB,
                DIB => REG_IB,
                DIPB => PI,
                DOB => REG_OB,
                DOPB => POB);

    ADA <= "00" & REGAD_S;
    ADB <= "00" & REGAD_D when (SEL = '1') else
            "00" & REGAD_T;
    WE <= WEX when (SEL = '1') else
         '0';


--  REG_S <= REG_FILE(CONV_INTEGER(REGAD_S));
--  REG_T <= REG_FILE(CONV_INTEGER(REGAD_T));

  -- purpose: register write
--  WPROC: process (CLK)
--  begin  -- process WPROC
--    if CLK'event and CLK = '1' then
--      REG_FILE(CONV_INTEGER(REGAD_D)) <= REG_D;      
--    end if;
--  end process WPROC; 

end ARC;

